<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width-device-width, initial-scale=1.0">
        <title>Trainee meeting #8 registro y login</title>
    </head>
    <body>
        <h3>Registro de Usuario:</h3>
        <form id="formRegistro">
            <label for="nombre">Nombre: </label>
            <input type="text" id="nombre" value="" required>
            <br>
            <label for="apellido">Apellido: </label>
            <input type="text" id="apellido" value="" required>
            <br>
            <label for="email">Email: </label>
            <input type="email" id="email" value="" required>
            <br>
            <label for="pais">Pais: </label>
            <input type="text" id="pais" value="" required>
            <br>
            <label for="pass">Contraseña: </label>
            <input type="password" id="pass" value="" required>
            <br>
            <label for="pass2">Repetir Contraseña: </label>
            <input type="password" id="pass2" value="" required>
            <button type="button" id="btnRegistrar">Registrar</button>
        </form>
        
        <h3>Login de Usuario:</h3>
        <form>
            <label for="emailLogin">Email: </label>
            <input type="email" id="emailLogin" value="" required>
            <br>
            <label for="passLogin">Contraseña: </label>
            <input type="password" id="passLogin" value="" required>
            <br>
            <button type="button" id="btnLogin">Ingresar</button>
        </form>
        <script>
            let usuarios = [];

            class Usuario {
                constructor(nombre, apellido, email, pais, pass){
                    this.nombre = nombre;
                    this.apellido = apellido;
                    this.email = email;
                    this.pais = pais;
                    this.pass = pass;
                }
            }

            // Esta funcion toma los valores ingresados del form los captura en una instancia de Usuario y los guarda en array //
            function guardarDatosUsuario(user) {
                usuarios.push(user);
                alert('Usuario guardado con exito.' + user.nombre);
            }

            // Esta funcion valida que los campos obligatorios no se dejen vacios //
            function validarCamposObligatorios() {
                let nombre = document.getElementById('nombre').value;
                let apellido = document.getElementById('apellido').value;
                let email = document.getElementById('email').value;
                let pais = document.getElementById('pais').value;
                let pass = document.getElementById('pass').value;
                let pass2 = document.getElementById('pass2').value;
                if (!nombre || !apellido || !email || !pais || !pass || !pass2) {
                    alert('Todos los campos son obligatorios');
                } else {
                    let user = new Usuario(nombre, apellido, email, pais, pass);
                    validarPass(user);
                }
            }

            // Esta funcion valida que las dos contraseñas ingresadas coincidan //
            function validarPass(user) {
                let pass = document.getElementById('pass').value;
                let pass2 = document.getElementById('pass2').value;

                if (pass !== pass2) {
                    alert('Las contraseñas no coinciden.');
                } else {
                    validarEmailUnico(user);
                }
            }

            // Esta funcion valida que el email no se encuentre registrado //
            function validarEmailUnico (user) {
                let bandera = true;
                for (let i = 0; i<usuarios.length; i++) {
                    if (usuarios[i].email === user.email) {
                        bandera = false;
                        alert('El email ya se encuentra registrado');
                        break;
                    }
                }
                if (bandera) guardarDatosUsuario(user);
            }

            // Funcion p/ validar login de usuario //
            function validarLogin() {
                let email = document.getElementById('emailLogin').value;
                let pass = document.getElementById('passLogin').value;

                for (let i = 0; i<usuarios.length; i++) {
                    if (usuarios[i].email === email && usuarios[i].pass === pass) {
                        return i;
                    }
                }
                return false;
            }

            // Accion de boton form registro //
            document.getElementById("btnRegistrar").addEventListener("click", function() {
                validarCamposObligatorios();
            });

            // Accion de boton form login //
            document.getElementById("btnLogin").addEventListener("click", function() {
                let result = validarLogin();
                console.log(result);
            });
        </script>
    </body>
</html>